/*
{
  "DESCRIPTION": "http://glslsandbox.com/e#55036.0",
  "INPUTS": [
      {
      "NAME": "Factor1",
      "TYPE": "float",
      "DEFAULT": 0.05,
      "MIN": 0.01,
      "MAX": 1.0
    },
	      {
      "NAME": "Factor2",
      "TYPE": "float",
      "DEFAULT": 0.0,
      "MIN": 0.0,
      "MAX": 100.0
    },
	{
			"NAME": "C2",
			"TYPE": "color",
			"DEFAULT" :   [ 0.6, 0.2, 0.4, 1.0 ]
		},
		{
			"NAME": "C3",
			"TYPE": "color",
			"DEFAULT" :   [ 0.6, 0.2, 0.4, 1.0 ]
		}
  ]
*/

#extension GL_OES_standard_derivatives : enable

#ifdef GL_ES
precision mediump float;
#endif

// glslsandbox uniforms

// shadertoy emulation
#define iTIME TIME
#define iRENDERSIZE RENDERSIZE

// --------[ Original ShaderToy begins here ]---------- //
#define S(v) smoothstep(-.5,.5, (v)/fwidth(v))
void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = fragCoord / iRENDERSIZE.x;

    vec3 col = vec3(0,0,0);    

    	float tri = S(sin((uv.y + iTIME * -Factor1) * (100.0-Factor2) + (100.0 -Factor2) * (abs(mod(uv.x, Factor1) - (Factor1/2.0)))));
        col = mix(C2.xyz, C3.xyz, tri);

    // Output to screen
    fragColor = vec4(col,1.0);
}
// --------[ Original ShaderToy ends here ]---------- //

void main(void)
{
    mainImage(gl_FragColor, gl_FragCoord.xy);
}